package com.simonstl.moe;

import java.util.Collection;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The ComponentCollection interface defines the bare minimum of functionality needed for the ordered and unordered content contained in MOE objects.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 21 August 2001
* @author Simon St.Laurent
**/

public interface ComponentCollectionI extends Collection {
/**
* toString(ComponentSet namespaceContext) should report as attributes for unordered content, elements for ordered, with an understanding of the namespaces already declared.
**/

public String toString(ComponentSet namespaceContext);
/**
* toString() should report as attributes for unordered content, elements for ordered.
**/

public String toString();

/**
* Given a list of current namespaces, the collection should report itself as XML attributes without declarations for namespaces presently in use.
**/

public String toAttributes(ComponentSet namespaceContext);

/**
*Without a list of current namespaces, the collection should report itself as XML attributes with declarations for all namespaces used by those attributes.
**/

public String toAttributes();

/**
* Given a list of current namespaces, the collection should report itself as XML elements without declarations for namespaces presently in use.
**/


public String toElements(ComponentSet namespaceContext);


/**
*Without a list of current namespaces, the collection should report itself as XML elements with declarations for all namespaces used by those attributes.
**/
public String toElements();

/**
* Sets the parent objects on all the items contained in the Collection.
**/
public void setParent(CoreComponentI _parent);

}