package com.simonstl.moe;

import java.util.ArrayList;
import java.util.Iterator;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The ComponentList class extends ArrayList with functions for matching objects.  ComponentList is a container for MOE objects which were generated outside of a document parsing environment - from a rules file, for instance.  Developers who need to put a collection of MOE objects into a cluster with semi-transparent matching capability should use ComponentList.</p>
*
* <p>Version 0.01 is a foundation built on ArrayList .</p>
*
* @version 0.01 23 August 2001
* @author Simon St.Laurent
*/

public class ComponentList extends ArrayList implements ComponentListI {

public String getTextContent() {
  String returnVal="";
  int size=this.size();
  for (int i=0; i<size;i++) {
     CoreComponentI node=(CoreComponentI) this.get(i);
     returnVal=returnVal+node.getTextContent();
  }
  return returnVal;
}

public String toString(){
  return this.toElements();
}

public String toString(ComponentSet namespaceContext){
  return this.toElements(namespaceContext);
}

public String toAttributes(ComponentSet namespaceContext){
  return "ComponentList.toAttributes(namespaceContext) not yet implemented.";
}

public String toAttributes(){
  return "ComponentList.toAttributes() not yet implemented.";
}

public String toElements(ComponentSet namespaceContext){
   String returnVal="";
   
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
      returnVal=returnVal+(next.toString(namespaceContext));
   }

   return returnVal;

}

public String toElements(){
   String returnVal="";
   
   Iterator it=this.iterator();

   while (it.hasNext()) {
      Object next=it.next();
      returnVal=returnVal+(next.toString());
   }

   return returnVal;

}

public void setParent(CoreComponentI _parent){
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
      next.setParent(_parent);
   }

}


public Object clone() {
   ComponentList returnVal=new ComponentList();
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
      returnVal.add(next.clone());
   }

   return (Object) returnVal;
}

}