package com.simonstl.moe;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The ComponentOutputI interface defines the bare minimum of functionality needed for programs to present MOE objects.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 21 August 2001
* @author Simon St.Laurent
**/

public interface ComponentOutputI {
/**NOTSTART indicates that the source hasn't started reporting.**/
public static final int NOTSTARTED=0;
/**COLLECTING indicates that the source is waiting for something to happen.**/
public static final int COLLECTING=1;
/**FINISHED indicates that the source is done.**/
public static final int FINISHED=2;

/**CHUNKS means to send larger components.**/
public static final int CHUNKS=0;
/**SAX indicates that the source should send information as start/content/end.**/
public static final int SAX=1;



/**
* getStatus allows impatient listeners to find out what's going on.  A status of 0 means that no information has been retrieved yet, a status of 1 means that it's collecting information locally, and maybe I'll come up with other useful bits. 2 means it's done.
**/
  public int getStatus();

/**
* setReport tells the outputter whether to report content as the largest objects it knows (0), a SAX-like view of content(1), or some other view (other numbers.)  If an outputter doesn't understand a request, it should return false.
**/
  public boolean setReport(int typeReport);

/**
* getCurrentComponent provides rude access to the component currently being handled, if any.  This one may disappear, as it seems outright dangerous, but there may be cases where it's useful.
**/
  public CoreComponentI getCurrentComponent();

/**
* setListener assigns a ComponentInputI object to listen to events generated by this component.  (This is basically the SAX model, calling them listeners rather than handlers.)
**/
  public void setListener(ComponentInputI listener);

}