package com.simonstl.moe;

import java.util.HashSet;
import java.util.Iterator;
import org.xml.sax.helpers.AttributesImpl;
import org.xml.sax.Attributes;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The ComponentSet class extends HashSet to support unordered content (typically but not necessarily attributes) for document components.</p>
*
* <p>Version 0.01 is based on the ComponentCollection class from <a href="http://simonstl.com/projects/fragment">FragmentFilter</a>.</p>
*
* @version 0.01 24 August 2001
* @author Simon St.Laurent
*/



public class ComponentSet extends HashSet implements ComponentSetI {
public String toString(){
  return this.toAttributes();
}
public String toString(ComponentSet namespaceContext){
  return this.toAttributes(namespaceContext);
}


public String toAttributes(ComponentSet namespaceContext){
  return "ComponentSet.toAttributes() not yet implemented.";
}

/**
* Warning: namespace collisions are possible in attributes.  Whichever namespace is encountered last will be the one declared.
**/

public String toAttributes(){
   String returnVal="";
   
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
//modify to support namespaces

      if (next.getPrefix()!=null) {
        returnVal=returnVal+next.getPrefix()+":";
      }
      returnVal=returnVal+next.getLocalName()+"=\"";
      returnVal=returnVal+next.getTextContent()+"\" ";

   }

   return returnVal;

}

public String toElements(ComponentSet namespaceContext){
  return "ComponentSet.toElements() not yet implemented.";
}

public String toElements(){
  return "ComponentSet.toElements() not yet implemented.";
}

public void setParent(CoreComponentI _parent){
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
      next.setParent(_parent);
   }

}

public Object clone() {
   ComponentSet returnVal=new ComponentSet();
   Iterator it=this.iterator();

   while (it.hasNext()) {
      CoreComponentI next=(CoreComponentI) it.next();
      returnVal.add(next.clone());
   }

   return (Object) returnVal;
}



}