package com.simonstl.moe;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The MutableComponentI interface defines one extra feature which can be used to create objects which change role depending on program whim.  These objects can be used in the MOE Framework.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 13 September 2001
* @author Simon St.Laurent
**/

public interface MutableComponentI extends CoreComponentI {

/**
* Set the basic type of this object, per the constants defined in the {@link com.simonstl.moe.CoreComponentI CoreComponentI} interface.
<pre>
public static final int DOCUMENT=0;
public static final int END_DOCUMENT=1;
public static final int ELEMENT=2;
public static final int END_ELEMENT=3;
public static final int ATTRIBUTE=4;
public static final int END_ATTRIBUTE=5;
public static final int COMMENT=6;
public static final int END_COMMENT=7;
public static final int PI=8;
public static final int END_PI=9;
public static final int DOCTYPE=10;
public static final int END_DOCTYPE=11;
public static final int CDATA=12;
public static final int END_CDATA=13;


public static final int XML_DECL=18;
public static final int NAMESPACE_DECL=20;
public static final int END_NAMESPACE=21;

public static final int GENERIC=64;
public static final int END_GENERIC=65;

public static final int GEN_ENTITY_START=130;
public static final int GEN_ENTITY_END=131;

public static final int GEN_ENTITY_REF=250;
public static final int IG_WHITESPACE=252;
public static final int CHARS=254;

public static final int UNPARSED=258;</pre>


This permits the creation of classes which change type depending on context.
**/
public void setBasicType(int Type);





}