package com.simonstl.moe;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The NamingI interface defines the bare minimum of functionality needed to work with XML names (compounds of URI, local name, and prefix) with MOE.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 1 September 2001
* @author Simon St.Laurent
**/

public interface NamingI extends Cloneable {

/**
* Returns a key which can be used as a unique identifier for this component.
**/
public int hashCode();

/**
* Accepts a URI reference value which is used as the namespace for the component.
**/
public void setNsURI(String newNsURI) ;

/**
* Returns the URI reference value for the namespace.
**/
public String getNsURI() ;

/**
* Accepts a string which will serve as the local name for this component.
**/
public void setLocalName(String newLocalName);

/**
* Returns the local name for the component
**/
public String getLocalName();

/**
* Accepts a string which serves as the prefix for this component.
**/
public void setPrefix(String newPrefix);

/**
* Returns the prefix used to represent the namespace URI reference for this component.
**/
public String getPrefix();

/**
* Returns the Qualified Name (QName) for the component.
**/
public String getQName();

/**
* Sets the Qualified Name (QName) for the component.  Overrides current local name and prefix, if any.
**/
public void setQName(String QName);


/**
* Returns a clean copy of the component and its contents.
**/
public abstract Object clone() ;

}