package com.simonstl.moe.adapter;

import com.simonstl.moe.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The MOETreeModelA adapter class provides a Swing-based javax.swing.Tree.TreeModel view of MOE objects.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 20 September 2001
* @author Simon St.Laurent
**/

public class MOETreeModelA implements TreeModel {

protected MOENodeWrapperA root=new MOENodeWrapperA();

public void setComponent(CoreComponentI _component) {
   root.setComponent(_component);
}

public CoreComponentI getComponent(){
   return root.getComponent();
}

public void addTreeModelListener(TreeModelListener listener) {
//currently ignored - trees are read-only
}

public void removeTreeModelListener(TreeModelListener listener) {
//currently ignored - trees are read-only
}

public Object getChild(Object parent, int index) {
  MOENodeWrapperA nodeWrap=(MOENodeWrapperA) parent;

  return nodeWrap.getChild(index);
}

public int getChildCount(Object parent){
  MOENodeWrapperA nodeWrap=(MOENodeWrapperA) parent;

  return nodeWrap.getChildCount();

}

public int getIndexOfChild(Object parent, Object child){
  MOENodeWrapperA nodeWrap=(MOENodeWrapperA) parent;

  return nodeWrap.getIndexOfChild(child);

}

public Object getRoot(){
return root;

}

public boolean isLeaf(Object node){
  MOENodeWrapperA nodeWrap=(MOENodeWrapperA) node;
  return nodeWrap.isLeaf();

}

public void valueForPathChanged(TreePath path, Object newValue){
//currently ignored - trees are read-only
}

}