package com.simonstl.moe.explicit;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;
import java.util.Map;
import com.simonstl.moe.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The Element class provides a foundation for MOE objects to store elements.</p>
*
* 
* <p>version 0.01 is the initial release and contains plenty of bogus placeholder functionality.</p>
*
* @version 0.01 25 August 2001
* @author Simon St.Laurent
**/

public class Element extends CoreComponent {


public String toString() {
/*System.out.println("prefix: "+getPrefix());
System.out.println("localName: "+getLocalName());
System.out.println("nsURI: "+getNsURI());*/
   String returnVal="<";


   returnVal=returnVal+getQName();


   if (getNsURI()!=null) {
     returnVal=returnVal+" xmlns";
     if (getPrefix()!=null) {
       returnVal=returnVal+":"+getPrefix();
     }
     returnVal=returnVal+"=\""+getNsURI()+"\"";
   }

   if (unorderedContent!=null) {
     returnVal=returnVal+" "+unorderedContent.toString();
   }

   if ((content==null)&& (complete)) {
     returnVal=returnVal+" />";
   } else {
     returnVal=returnVal+">";
   }

   if (content!=null) {
     returnVal=returnVal+content.toString();
   }


   if ((content!=null) && (complete)) {
     returnVal=returnVal+"</";
     returnVal=returnVal+getQName()+">";


   }

   return returnVal;
}

public String toString(ComponentSetI namespaceContext){
  return "Element.toString(ComponentSetI namespaceContext) not yet implemented.";
}

public Object clone() {
   CoreComponentI newComponent=new Element();
   if (getName()!=null) {
     NamingI newName=(NamingI) this.getName().clone();
     newComponent.setName(newName);
   }
   if (getContent()!=null) {
     ComponentListI newContent=(ComponentListI) this.getContent().clone();
     newContent.setParent(newComponent);
     newComponent.setContent(newContent);
   }
   if (getUnorderedContent()!=null) {
     ComponentSetI newUnorderedContent=(ComponentSetI) this.getUnorderedContent().clone();
     newUnorderedContent.setParent(newComponent);
     newComponent.setUnorderedContent(newUnorderedContent);
   }
   if (getUnorderedContent()!=null) {
     AnnotableI thisAnnotations=(Annotations) this.getAllAnnotations();
     AnnotableI newAnnotations=(Annotations) thisAnnotations.clone();

     newComponent.addAll((Map) newAnnotations);
   }
   newComponent.setIsComplete(this.getIsComplete());

   return (Object) newComponent;
}

/**
* Element has the basic type ELEMENT.  Duh.
**/
public int getBasicType() {
   return ELEMENT;
}

/**
* For now, the Element class doesn't listen.  I may revisit this decison later.
**/
public boolean listen (CoreComponentI component) throws MOEException{
  return super.listen(component);
}




public static void main (String[] args) throws Exception {
    int numArgs=args.length;
    Element element=new Element();

 if (numArgs<3) {
    System.out.println("need more arguments!");
 } else { 
   element.setNsURI(args[0]);
   element.setLocalName(args[1]);
 
 for (int i=2; i<numArgs; i++) {
   Characters addChars=new Characters();
   addChars.setContent(args[i]+" ");
   element.addContent(addChars);
 }//end for

 if (numArgs>5) {element.setIsComplete(true);}

   element.print();
 }//end else

}

}