package com.simonstl.moe.namespace;

import com.simonstl.moe.*;
import java.util.Set;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The NamespaceSetI interface extends {@link com.simonstl.moe.ComponentSetI ComponentSetI}, with some extra functions for Namespaces </p>
*<p>This interface is just getting started.</p>
*
* <p>Version 0.01 is foundation.</p>
*
* @version 0.01 24 August 2001
* @author Simon St.Laurent
*/
public interface NamespaceSetI extends Set, ComponentSetI {

/** Given a URI, it returns the first prefix it finds matching it.  Because multiple namespace prefixes may be mapped to a given URI, this may not return the expected prefix.**/
public String getURI(String prefix);

/** Given a prefix, it returns the URI to which that prefix maps.  This is a processed set of namespaces applying to a current context, so only one URI will be returned.**/

public String getPrefix(String URI);

}