package com.simonstl.moe.test;

import org.xml.sax.SAXException;
import org.xml.sax.helpers.XMLFilterImpl;
import com.simonstl.moe.*;
import com.simonstl.moe.explicit.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The ComponentGenAttNest class creates a single complex MOE object with attributes and sends it to a listener class.</p>
*
* 
* <p>version 0.01 is the initial release and contains plenty of bogus placeholder functionality.</p>
*
* @version 0.01 27 August 2001
* @author Simon St.Laurent
**/

public class ComponentGenAttNest {


public static void main (String[] args) throws Exception {

ComponentInputI listener=new ComponentInputPrint();

CoreComponentI root=generate();

listener.listen(root);


}

public static CoreComponentI generate() throws MOEException {
Element root=new Element();
root.setLocalName("taco");
root.setNsURI("http://example.com/tacotest");
root.setPrefix("tasty");

Element zippy=new Element();
zippy.setLocalName("zippy");

Attribute colorAtt=new Attribute();
colorAtt.setLocalName("color");
colorAtt.setContent("green");

zippy.addUnorderedContent(colorAtt);

zippy.setIsComplete(true);

root.listen(zippy);

Element unqual=new Element();
unqual.setLocalName("unqualified");

Attribute unqualAtt=new Attribute();
unqualAtt.setLocalName("unqualAtt");
unqualAtt.setContent("test");

unqual.addUnorderedContent(unqualAtt);

root.listen(unqual);

//root.print();

EndElement endUnqual=new EndElement();
endUnqual.setLocalName("unqualified");

root.listen(endUnqual);

//root.print();

Element defaultNS=new Element();
defaultNS.setLocalName("qualified");
defaultNS.setNsURI("http://example.com/qual/");

root.listen(defaultNS);

Characters chars=new Characters();
chars.setContent("howdy, just testing text!");
root.listen(chars);

CDATASect cdataSect=new CDATASect();
cdataSect.setContent("howdy, just testing CDATA!");
root.listen(cdataSect);

EndCDATASect endCdataSect=new EndCDATASect();
root.listen(endCdataSect);


EndElement endDefaultNS=new EndElement();
endDefaultNS.setLocalName("qualified");
endDefaultNS.setNsURI("http://example.com/qual/");

root.listen(endDefaultNS);

Element endRoot=new EndElement();
endRoot.setLocalName("taco");
endRoot.setNsURI("http://example.com/tacotest");
endRoot.setPrefix("tasty");


root.listen(endRoot);

return root;
}

}