package com.simonstl.moe.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.beans.*;
import com.simonstl.moe.adapter.*;
import com.simonstl.moe.*;
import com.simonstl.moe.test.*;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The MOETree class provides a JTree-based view of MOE objects, using the {@link com.simonstl.moe.adapter.MOETreeModelA MOETreeModelA} and {@link com.simonstl.moe.adapter.MOENodeWrapperA MOENodeWrapperA} classes.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 20 September 2001
* @author Simon St.Laurent
**/

public class MOETree extends JTree implements TreeWillExpandListener {

protected TreeModel thisModel;

public MOETree(TreeModel model) {
  super(model);
  thisModel=model;
  this.setShowsRootHandles(true);
  this.setRowHeight(-1);
// System.out.println(this.isFixedRowHeight());
  this.setCellRenderer(new MOETreeCellRenderer());
  this.addTreeWillExpandListener(this);
}

public void treeWillExpand(TreeExpansionEvent tee) throws ExpandVetoException {
  MOENodeWrapperA node=(MOENodeWrapperA)tee.getPath().getLastPathComponent();
  node.setExpanded(true);
//  System.out.println("Set "+node.toString()+" to expanded");
}
public void treeWillCollapse(TreeExpansionEvent tee) throws ExpandVetoException {
  MOENodeWrapperA node=(MOENodeWrapperA)tee.getPath().getLastPathComponent();
  node.setExpanded(false);
//  System.out.println("Set "+node.toString()+" to collapsed");
}

}