package com.simonstl.moe.ui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.beans.*;
import com.simonstl.moe.adapter.*;
import com.simonstl.moe.*;
import com.simonstl.moe.test.*;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* <p>The MOETreeCellRenderer class provides a more detailed presentation MOE objects in trees.</p>
*
* <p>version 0.01 is the initial release.</p>
*
* @version 0.01 21 September 2001
* @author Simon St.Laurent
**/

public class MOETreeCellRenderer extends JPanel implements TreeCellRenderer {

  JLabel text=new JLabel();
  JScrollPane textHold=new JScrollPane();
  final boolean DEBUG=false;
  String toolTip="heh";

public MOETreeCellRenderer() {

  this.setLayout(new GridBagLayout());
  this.setOpaque(false);
  text.setOpaque(false);

/*  text.setFont(new Font("Monospaced", Font.PLAIN, 12));
//  text.setEditable(false);
  text.setHorizontalAlignment(SwingConstants.LEFT);
  text.setHorizontalTextPosition(SwingConstants.LEFT);
  text.setVisible(true);
  Dimension minSize=new Dimension(400, 24);
  Dimension prefSize=new Dimension (630, 24);
  Dimension textPrefSize=new Dimension (630, 48);
  text.setMinimumSize(minSize);
  text.setPreferredSize(textPrefSize);
  this.setMinimumSize(minSize);
  this.setPreferredSize(prefSize);*/
}


public String getToolTipText() {
  return toolTip;
}

public Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
  text.setText(value.toString());
  toolTip=((MOENodeWrapperA) value).getToolTip();

  if (selected) {
  this.setOpaque(true);
//  this.setForeground(Color.blue);

  } else {
  this.setOpaque(false);
//  this.setForeground(Color.red);
  }


//  text.setLineWrap(true);
//  this.add(icon);

//  textHold.add(text);
  this.add(text);
  return this;
}

private ImageIcon icon=new ImageIcon("icons/element.gif");


public void firePropertyChange(String propertyName, long oldValue, long newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, int oldValue, int newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, boolean oldValue, boolean newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, short oldValue, short newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, char oldValue, char newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, byte oldValue, byte newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, float oldValue, float newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, double oldValue, double newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void firePropertyChange(String propertyName, Object oldValue, Object newValue){
if (DEBUG) {
  System.out.println("Property: "+propertyName+" from "+oldValue+" to "+newValue);
}
  super.firePropertyChange(propertyName, oldValue, newValue);
}

public void setSize(Dimension d){
if (DEBUG) {
  System.out.println("Size: " + d);
}
  super.setSize(d);
}

public void reshape(int x, int y, int w, int h){
if (DEBUG) {
  System.out.println("text:"+text.getText()+ "x:"+x+ " y:"+y+ "w:"+w+ "h:"+h);
}
  text.setHorizontalAlignment(SwingConstants.LEFT);
  super.reshape(x,y,w,h);
}


}